<?php

namespace Lumpik;

use FML\ManiaCode;
use FML\ManiaLink;
use FML\Controls\Control;
use FML\Controls\Frame;
use FML\Controls\Label;
use FML\Controls\Labels\Label_Text;
use FML\Controls\Labels\Label_Button;
use FML\Controls\Quad;
use FML\Controls\Quads\Quad_Icons64x64_1;
use FML\Controls\Quads\Quad_BgRaceScore2;
use ManiaControl\Admin\AuthenticationManager;
use ManiaControl\Callbacks\Callbacks;
use ManiaControl\Callbacks\CallbackListener;
use ManiaControl\Callbacks\CallbackManager;
use ManiaControl\Callbacks\TimerListener;
use ManiaControl\Callbacks\TimerManager;
use ManiaControl\Callbacks\Structures\ArmorEmptyStructure;
use ManiaControl\Callbacks\Structures\NearMissStructure;
use ManiaControl\Callbacks\Structures\CaptureStructure;
use ManiaControl\Callbacks\Structures\PlayerHitStructure;
use ManiaControl\Commands\CommandListener;
use ManiaControl\Logger;
use ManiaControl\ManiaControl;
use ManiaControl\Manialinks\ManialinkPageAnswerListener;
use ManiaControl\Manialinks\IconManager;
use ManiaControl\Manialinks\ManialinkManager;
use ManiaControl\Maps\MapManager;
use ManiaControl\Players\Players;
use ManiaControl\Players\Player;
use ManiaControl\Players\PlayerManager;
use ManiaControl\Plugins\Plugin;


// Include FML
require_once __DIR__ . '/../../libs/FML/autoload.php';

// DEBUG MODE
define('ManiaControl\DEV_MODE', false);



/**
 * Sound Events Manager (SEM) plugin.
 *
 * For any bug/suggestion : https://forum.maniaplanet.com/viewtopic.php?f=479&t=30285
 *
 *
 * V1.00 : Initial version
 * V1.01 : Music player, RESET_ON_NEW_ROUND and URL parameters
 * V1.02 : MESSAGES and RANKING can be enabled/disabled by players with new icons. All icons are gathered into new menu. Default RESET_ON_NEW_ROUND set to true for Siege.
 *
 *
 * @author Lumpik
 *
 */
 
 
 
 /*		
	TO DO :
		joueurs doivent pouvoir couper la musique (mais ne pas la démarrer)
		créer SOUND_HIT_ROX, SOUND_HIT_RAIL, SOUND_HIT_OTHER
		
		ajouter les callbacks pour les phases : possible dans une prochaine version de SB
		ajouter les headshots
		delai pour les frags (utile ??)
		ajouter Red_Team_takes_the_lead.wav : tester GetRoundCustomPoints() from http://methods.xaseco.org/methodstmc.php
		son spécial pour un kill du porteur de ball
		ajouter de la pub pour le plugin dans des messages ? En début de map ? --> ca craint un peu l'auto-pub....
 */

 
 /*
 LIENS UTILES :
 http://www.maniacontrol.com/user/plugins/70
 http://www.maniacontrol.com/docs
 http://slig.info/ms/docs/2012-08-14/html/annotated.htmlok
 
 SPEEDBALL GITHUB :
 https://github.com/steeffeen/ManiaPlanet-Scripts/blob/master/Modes/ShootMania/SpeedBall.Script.txt
 
 UT sounds :
 http://unrealtournament.99.free.fr/utfiles/index.php?dir=sound%20ut/
 
 LIST OF KILL AWARDS (check Unreal Tournament) :
 http://en.wikipedia.org/wiki/Deathmatch
 
 PLAYING SOUNDS WITH FML (Fancy Mania Links) :
 https://forum.maniaplanet.com/viewtopic.php?f=465&t=26099
 https://github.com/steeffeen/FancyManiaLinks/blob/master/examples/audio.php
 https://github.com/steeffeen/FancyManiaLinks/blob/master/FML/Controls/Audio.php
 https://github.com/steeffeen/FancyManiaLinks/blob/master/FML/Types/Playable.php
 https://github.com/steeffeen/FancyManiaLinks/blob/master/FML/Controls/Control.php
 
 
 https://github.com/ManiaControl/ManiaControl/blob/master/core/Callbacks/LibXmlRpcCallbacks.php
 */

 
 /*
   MODIFYING SPEEDBALL SCRIPT TO GET PHASES :
   https://github.com/steeffeen/ManiaPlanet-Scripts/blob/master/Modes/ShootMania/SpeedBall.Script.txt
   https://github.com/steeffeen/ManiaPlanet-Scripts/blob/master/Libs/steeffeen/ShootMania/SpeedBallXmlRpc.Script.txt
   
   *************************
      PASS :
   *************************
   IN SpeedBallXmlRpc.Script.txt
   
   // Callback for passes
	Void OnPass(CSmModeEvent _Event) {
	declare ShooterLogin = "Null";
	declare VictimLogin = "Null";
	declare Distance = 0;
	if (_Event.Shooter != Null) ShooterLogin = _Event.Shooter.Login;
	if (_Event.Victim != Null) VictimLogin = _Event.Victim.Login;
		==> if (_Event.Shooter != Null && _Event.Victim != Null) MathLib::Distance(_Event.Shooter.Position, _Event.Victim.Position);
		==> declare Data = [ShooterLogin, VictimLogin, TextLib::ToText(_Event.WeaponNum), Distance];
	Private_SendCallbackArray(CB_OnPass, Data);
	}
  
	
	
	
	
	
	*************************
	   PHASES :
	*************************
	IN SpeedBall.Script.txt :
	
	// Handle pending events
	foreach (Event in PendingEvents) {
		==> A PRIORI, on ne peut pas envoyer d'event pour les phases car pas d'event déclaré par SM !
		
		
	
	if (Now >= UIManager.UIAll.CountdownEndTime && UIManager.UIAll.CountdownEndTime > 0) {
		// New gameplay phase!
		G_Phase += 1;
		switch (G_Phase) {
			case 1: {
				// Reduction phase began
				UIManager.UIAll.SendNotice(TextLib::Compose("$fc3%1", _("Reduction Phase!")),
					CUIConfig::ENoticeLevel::MatchWarning, Null, CUIConfig::EAvatarVariant::Default,
					CUIConfig::EUISound::PhaseChange, 0);
				UIManager.UIAll.CountdownEndTime = Now + S_TimeLimitReduction * 1000;
				SBXmlRpc::OnPhase(G_Phase);
			}
			case 2: {
				// Instant phase began
				UIManager.UIAll.SendNotice(TextLib::Compose("$f60%1", _("Instant Phase!")),
					CUIConfig::ENoticeLevel::MatchWarning, Null, CUIConfig::EAvatarVariant::Default,
					CUIConfig::EUISound::PhaseChange, 1);
				UIManager.UIAll.CountdownEndTime = -1;
				SBXmlRpc::OnPhase(_Event);
			}
		}
	}
	
	
	----------
	IN SpeedBallXmlRpc.Script.txt :
	
	#Const CB_OnPhase	"SpeedBall_OnPhase"
	
	// Callback for phases
	Void OnPhase(Integer Phase) {
		Private_SendCallbackArray(CB_OnPhase, Phase);
	}
	
	
*/

 


class SoundEventsManager implements CallbackListener, CommandListener, TimerListener, ManialinkPageAnswerListener, Plugin {
	
    /**
     * Constants
     */
    const ID			= 70;
    const VERSION		= 1.02;
    const NAME			= 'Sound Events Manager';
    const AUTHOR		= 'Lumpik';
	const DESCRIPTION	= 'Play sounds on triggers, such as kills, beginning of round, etc...';
	
	// ManiaLinks ID
	const ML_ICON_MENU_ID			= 'SEM.ManiaLink.Icon.Menu.Id';
	const ML_ICON_MUSIC_ID			= 'SEM.ManiaLink.Icon.Music.Id';
	const ML_ICON_SOUND_ID			= 'SEM.ManiaLink.Icon.Sound.Id';
	const ML_ICON_MESSAGE_ID		= 'SEM.ManiaLink.Icon.Message.Id';
	const ML_ICON_RANKING_ID		= 'SEM.ManiaLink.Icon.Ranking.Id';
	const ML_SOUND_ID				= 'SEM.ManiaLink.Sound.Id';
	const ML_MUSIC_ID				= 'SEM.ManiaLink.Music.Id';
	const ML_MESSAGE_ID				= 'SEM.ManiaLink.Message.Id';
	const ML_RANKING_ID				= 'SEM.ManiaLink.Ranking.Id';
	
	// Icons for menu
	const SEM_ICON_MENU				= 'sound_off.png';
	const SEM_ICON_MENU_PATH		= 'http://mm2monde.fr/Plugins/SoundEventsManager/Icones';
	const SEM_ICON_MENU_MOVER		= 'sound_off_mover.png';
	const SEM_ICON_MENU_MOVER_PATH	= 'http://mm2monde.fr/Plugins/SoundEventsManager/Icones';
	
	// Icons for enabling/disabling sounds
	// Icons from http://www.softicons.com/search?search=iconza+sound&x=0&y=0
	const SEM_ICON_SOUND_ON				= 'sound_on.png';
	const SEM_ICON_SOUND_ON_PATH		= 'http://mm2monde.fr/Plugins/SoundEventsManager/Icones';
	const SEM_ICON_SOUND_ON_MOVER		= 'sound_on_mover.png';
	const SEM_ICON_SOUND_ON_MOVER_PATH	= 'http://mm2monde.fr/Plugins/SoundEventsManager/Icones';
	const SEM_ICON_SOUND_OFF			= 'sound_off.png';
	const SEM_ICON_SOUND_OFF_PATH		= 'http://mm2monde.fr/Plugins/SoundEventsManager/Icones';
	const SEM_ICON_SOUND_OFF_MOVER		= 'sound_off_mover.png';
	const SEM_ICON_SOUND_OFF_MOVER_PATH	= 'http://mm2monde.fr/Plugins/SoundEventsManager/Icones';
	
	// Icons for enabling/disabling messages
	// Icons from http://www.softicons.com/search?search=iconza+text&x=0&y=0
	const SEM_ICON_MESSAGE_ON				= 'message_on.png';
	const SEM_ICON_MESSAGE_ON_PATH			= 'http://mm2monde.fr/Plugins/SoundEventsManager/Icones';
	const SEM_ICON_MESSAGE_ON_MOVER			= 'message_on_mover.png';
	const SEM_ICON_MESSAGE_ON_MOVER_PATH	= 'http://mm2monde.fr/Plugins/SoundEventsManager/Icones';
	const SEM_ICON_MESSAGE_OFF				= 'message_off.png';
	const SEM_ICON_MESSAGE_OFF_PATH			= 'http://mm2monde.fr/Plugins/SoundEventsManager/Icones';
	const SEM_ICON_MESSAGE_OFF_MOVER		= 'message_off_mover.png';
	const SEM_ICON_MESSAGE_OFF_MOVER_PATH	= 'http://mm2monde.fr/Plugins/SoundEventsManager/Icones';
	
	// Icons for enabling/disabling ranking
	// Icons from http://www.softicons.com/search?search=iconza+star&x=0&y=0
	// Other idea : http://www.softicons.com/sport-icons/pretty-office-vii-icons-by-custom-icon-design/podium-icon
	const SEM_ICON_RANKING_ON				= 'ranking_on.png';
	const SEM_ICON_RANKING_ON_PATH			= 'http://mm2monde.fr/Plugins/SoundEventsManager/Icones';
	const SEM_ICON_RANKING_ON_MOVER			= 'ranking_on_mover.png';
	const SEM_ICON_RANKING_ON_MOVER_PATH	= 'http://mm2monde.fr/Plugins/SoundEventsManager/Icones';
	const SEM_ICON_RANKING_OFF				= 'ranking_off.png';
	const SEM_ICON_RANKING_OFF_PATH			= 'http://mm2monde.fr/Plugins/SoundEventsManager/Icones';
	const SEM_ICON_RANKING_OFF_MOVER		= 'ranking_off_mover.png';
	const SEM_ICON_RANKING_OFF_MOVER_PATH	= 'http://mm2monde.fr/Plugins/SoundEventsManager/Icones';
	
	// Icons for enabling/disabling music
	// Icons from http://www.softicons.com/search?search=iconza+music&x=0&y=0
	const SEM_ICON_MUSIC_ON				= 'music_on.png';
	const SEM_ICON_MUSIC_ON_PATH		= 'http://mm2monde.fr/Plugins/SoundEventsManager/Icones';
	const SEM_ICON_MUSIC_ON_MOVER		= 'music_on_mover.png';
	const SEM_ICON_MUSIC_ON_MOVER_PATH	= 'http://mm2monde.fr/Plugins/SoundEventsManager/Icones';
	const SEM_ICON_MUSIC_OFF			= 'music_off.png';
	const SEM_ICON_MUSIC_OFF_PATH		= 'http://mm2monde.fr/Plugins/SoundEventsManager/Icones';
	const SEM_ICON_MUSIC_OFF_MOVER		= 'music_off_mover.png';
	const SEM_ICON_MUSIC_OFF_MOVER_PATH	= 'http://mm2monde.fr/Plugins/SoundEventsManager/Icones';
	
	// URL TO FORUM
	const URL	= '000. For any bug/suggestion : $lhttps://forum.maniaplanet.com/viewtopic.php?f=479&t=30285&p=238505#p238505';
	
	// DEBUG + VOLUME parameters
	const DEBUG			= '00a. DEBUG ';
	const VOLUME		= '00b. VOLUME';
	
	// ICON MENU parameter
	const SEM_ICON_MENU_POS_X = '00b00. ICON MENU : X position';
	const SEM_ICON_MENU_POS_Y = '00b01. ICON MENU : Y position';
	
	// MUSIC parameters
	const MUSIC_ENABLE	= '00b1. MUSIC enabled on new map ?';
	const MUSIC_VOLUME	= '00b2. MUSIC VOLUME';
	const MUSIC_LINK	= '00b3. MUSIC link';
	
	// MESSAGE
	const SEM_MESSAGES_POS_X	= '00c. MESSAGES : X position';
	const SEM_MESSAGES_POS_Y	= '00d. MESSAGES : Y position';
	const SEM_MESSAGES_SCALE	= '00e. MESSAGES : scale';
	
	// RANKING
	const SEM_RANKING_POS_X	= '00f. RANKING : X position';
	const SEM_RANKING_POS_Y	= '00g. RANKING : Y position';
	const SEM_RANKING_SCALE	= '00h. RANKING : scale';
	
	// IGNORED_PLAYERS_LIST parameter
	const IGNORED_PLAYERS_LIST	= '00i. IGNORE_LIST';
	
	// RESET_ON_NEW_ROUND parameter
	const RESET_ON_NEW_ROUND	= '00j. Reset killstreak on new round';
	
	// PLAYER_CONNECTED parameters
	const ENABLE_PLAYER_CONNECTED_SOUND	= '01a. PLAYER_CONNECTED enabled ?';
	const SOUND_LINK_PLAYER_CONNECTED	= '01b. PLAYER_CONNECTED sound';
	
	// PLAYER_DISCONNECTED parameters
	const ENABLE_PLAYER_DISCONNECTED_SOUND	= '02a. PLAYER_DISCONNECTED enabled ?';
	const SOUND_LINK_PLAYER_DISCONNECTED	= '02b. PLAYER_DISCONNECTED sound';
	
	// BEGIN_MAP parameters
	const ENABLE_BEGIN_MAP_SOUND	= '03a. BEGIN_MAP enabled ?';
	const SOUND_LINK_BEGIN_MAP		= '03b. BEGIN_MAP sound';
	
	// BEGIN_PLAYING parameters
	const ENABLE_BEGIN_PLAYING_SOUND	= '04a. BEGIN_PLAYING enabled ?';
	const SOUND_LINK_BEGIN_PLAYING		= '04b. BEGIN_PLAYING sound';
	
	// BLUE/RED TEAM SCORES parameters
	const ENABLE_TEAM_SCORES_SOUND		= '05a. TEAM_SCORES enabled ?';
	const SOUND_LINK_BLUE_TEAM_SCORES	= '05b. BLUE_TEAM_SCORES sound';
	const SOUND_LINK_RED_TEAM_SCORES	= '05c. RED_TEAM_SCORES sound';
	
	// BACKSPACE parameters
	const ENABLE_BACKSPACE_SOUND	= '06a. BACKSPACE enabled ?';
	const SOUND_LINK_BACKSPACE		= '06b. BACKSPACE sound';
	
	// OFFZONE parameters
	const ENABLE_OFFZONE_SOUND	= '07a. OFF-ZONE enabled ?';
	const SOUND_LINK_OFFZONE	= '07b. OFF-ZONE sound';
	
	// HIT parameters
	const ENABLE_HIT_SOUND	= '08c. HIT enabled ?';
	const SOUND_LINK_HIT	= '08d. HIT sound';
	
	// TEAMKILLER parameters
	const ENABLE_TEAMKILLER_SOUND	= '09a. TEAMKILLER enabled ?';
	const SOUND_LINK_TEAMKILLER	= '09b. TEAMKILLER sound';
	
	// KILL AWARDS parameters
	const ENABLE_KILL_AWARDS	= '100. KILLSTREAK (consecutive kills without dying) enabled ?';
	
	const SOUND_LINK_KILL_01	= '100.01. Sound for kill 01';
	const SOUND_LINK_KILL_02	= '100.02. Sound for kill 02';
	const SOUND_LINK_KILL_03	= '100.03. Sound for kill 03';
	const SOUND_LINK_KILL_04	= '100.04. Sound for kill 04';
	const SOUND_LINK_KILL_05	= '100.05. Sound for kill 05';
	const SOUND_LINK_KILL_06	= '100.06. Sound for kill 06';
	const SOUND_LINK_KILL_07	= '100.07. Sound for kill 07';
	const SOUND_LINK_KILL_08	= '100.08. Sound for kill 08';
	const SOUND_LINK_KILL_09	= '100.09. Sound for kill 09';
	const SOUND_LINK_KILL_10	= '100.10. Sound for kill 10';
	const SOUND_LINK_KILL_11	= '100.11. Sound for kill 11';
	const SOUND_LINK_KILL_12	= '100.12. Sound for kill 12';
	const SOUND_LINK_KILL_13	= '100.13. Sound for kill 13';
	const SOUND_LINK_KILL_14	= '100.14. Sound for kill 14';
	const SOUND_LINK_KILL_15	= '100.15. Sound for kill 15';
	const SOUND_LINK_KILL_16	= '100.16. Sound for kill 16';
	const SOUND_LINK_KILL_17	= '100.17. Sound for kill 17';
	const SOUND_LINK_KILL_18	= '100.18. Sound for kill 18';
	const SOUND_LINK_KILL_19	= '100.19. Sound for kill 19';
	const SOUND_LINK_KILL_20	= '100.20. Sound for kill 20';
	const SOUND_LINK_KILL_21	= '100.21. Sound for kill 21';
	const SOUND_LINK_KILL_22	= '100.22. Sound for kill 22';
	const SOUND_LINK_KILL_23	= '100.23. Sound for kill 23';
	const SOUND_LINK_KILL_24	= '100.24. Sound for kill 24';
	const SOUND_LINK_KILL_25	= '100.25. Sound for kill 25';
	const SOUND_LINK_KILL_26	= '100.26. Sound for kill 26';
	const SOUND_LINK_KILL_27	= '100.27. Sound for kill 27';
	const SOUND_LINK_KILL_28	= '100.28. Sound for kill 28';
	const SOUND_LINK_KILL_29	= '100.29. Sound for kill 29';
	const SOUND_LINK_KILL_30	= '100.30. Sound for kill 30';
	
	
	
    /**
     * Private Properties
     */
    private $maniaControl = null;
	
	// SEM
	public $playersScore = array();
	//public $disabledSoundsPlayers = array();
	public $disabledSoundsPlayers = array();
	public $disabledRankingPlayers = array();
	public $disabledMessagesPlayers = array();
	public $playerTeamId;
	public $scoreMin;
	public $soundLinkMin;
	public $scoreMax;
	public $soundLinkMax;
	public $musicEnabled = false;
	
	
	
    /**
     * Fonction de log pour debugg
     *
     * @param $log
     */
    public function toLog($log) {
		$DEBUG = $this->maniaControl->settingManager->getSettingValue($this, self::DEBUG);
		if ($DEBUG == true) {
			$this->maniaControl->getChat()->sendInformation('[Sound Events Manager][' . $this->getVersion() . '] ' . $log, null, false);
		}
    }
	
	
	
	/*
	 * Initialize the array which stores players' scores
	 */
	public function initializePlayersScore() {
		// Initialisation of playersScore[]
		foreach ($this->maniaControl->getPlayerManager()->getPlayers() as $player) {
			$playerLogin = $player->login;
			$this->playersScore[$playerLogin] = '0';
		}
	}
	
	
	
    /**
     * Prepares the Plugin
     *
     * @param ManiaControl $maniaControl
     */
    public static function prepare(ManiaControl $maniaControl) {
		//$this->toLog('into prepare()');
        //do nothing
    }
	
	/**
	 * Unload the plugin and its resources
	 */
    public function unload() {
		// DEBUG
		$this->toLog('Unloading Sound Events Manager...');
		
		// Reset arrays
		$this->playersScore = array();
		$this->disabledSoundsPlayers = array();
		$this->disabledRankingPlayers = array();
		$this->disabledMessagesPlayers = array();
		
		// Removing SEM Icon
		$this->removeMenuIcon();
		
		// Update ranking
		$this->ranking();
		
		// Callbacks
        $this->maniaControl->getCallbackManager()->unregisterCallbackListener($this);
    }
	
    /**
     * Load the plugin
     *
     * @param \ManiaControl\ManiaControl $maniaControl
     */
    public function load(ManiaControl $maniaControl) {
        $this->maniaControl = $maniaControl;
		
		$this->toLog('Loading Sound Events Manager...');
		
		// Detecting mode		
		// Cf http://mania-actu.com/browser/servers.php
		//    'SMStormElite@nadeolabs'
		//    'SMStormRoyal@nadeolabs'
		//    'SMStormSiege@nadeolabs'
		//    'SpeedBall@steeffeen'
		$mode = $this->maniaControl->server->titleId;
		$this->toLog('Mode is ' . $mode);
		$serverName = $this->maniaControl->server->login;
		$serverIp = $this->maniaControl->server->ip;
		$this->toLog("Server name is $serverName ($serverIp)");
		
		// Global variables
		$rep_sounds = 'http://mm2monde.fr/Plugins/SoundEventsManager/UnrealTournamentSounds/';
		$this->scoreMin = 666;
		$this->soundLinkMin = '';
		$this->scoreMax = 666;;
		$this->soundLinkMax = '';
		$this->disabledSoundsPlayers = array();
		$this->disabledRankingPlayers = array();
		$this->disabledMessagesPlayers = array();
	
		// Initialisation of players' score
		$this->initializePlayersScore();
		
        //Register callbacks
		$this->maniaControl->getCallbackManager()->registerCallbackListener(Callbacks::BEGINMAP, $this, 'onBeginMap');
		$this->maniaControl->getCallbackManager()->registerCallbackListener(Callbacks::BEGINPLAYING, $this, 'onBeginPlaying');
		$this->maniaControl->getCallbackManager()->registerCallbackListener(Callbacks::ONCAPTURE, $this, 'onCapture');
		$this->maniaControl->getCallbackManager()->registerCallbackListener(Callbacks::ONPLAYERREQUESTRESPAWN, $this, 'onRequestRespawn');
		//$this->maniaControl->getCallbackManager()->registerCallbackListener(Callbacks::ONSHOOT, $this, 'onShoot');
		$this->maniaControl->getCallbackManager()->registerCallbackListener(Callbacks::ONHIT, $this, 'onHit');
		$this->maniaControl->getCallbackManager()->registerCallbackListener(Callbacks::ONARMOREMPTY, $this, 'onArmorEmpty');
		
		$this->maniaControl->getCallbackManager()->registerScriptCallbackListener('SpeedBall_OnPass', $this, 'onPass');
		
		$this->maniaControl->getCallbackManager()->registerCallbackListener(PlayerManager::CB_PLAYERCONNECT, $this, 'handlePlayerConnect');
		$this->maniaControl->getCallbackManager()->registerCallbackListener(PlayerManager::CB_PLAYERDISCONNECT, $this, 'handlePlayerDisconnect');
		
		// URL message
		$this->maniaControl->settingManager->initSetting($this, self::URL, '$lhttps://forum.maniaplanet.com/viewtopic.php?f=479&t=30285&p=238505#p238505');
		
		// DEBUG messages
		$this->maniaControl->settingManager->initSetting($this, self::DEBUG, false);
		
		// VOLUME sound
		$this->maniaControl->settingManager->initSetting($this, self::VOLUME, 0.8);
		
		// ICON_MENU
		$this->maniaControl->settingManager->initSetting($this, self::SEM_ICON_MENU_POS_X, 156);
		$this->maniaControl->settingManager->initSetting($this, self::SEM_ICON_MENU_POS_Y, -10);
		
		// MUSIC Settings
		$this->maniaControl->settingManager->initSetting($this, self::MUSIC_ENABLE, false);
		$this->maniaControl->settingManager->initSetting($this, self::MUSIC_VOLUME, 0.5);
		$this->maniaControl->settingManager->initSetting($this, self::MUSIC_LINK, '');
		
		// MESSAGES
		$this->maniaControl->settingManager->initSetting($this, self::SEM_MESSAGES_POS_X, 0);
		$this->maniaControl->settingManager->initSetting($this, self::SEM_MESSAGES_POS_Y, 40);
		$this->maniaControl->settingManager->initSetting($this, self::SEM_MESSAGES_SCALE, 1.5);
		
		// RANKING
		$this->maniaControl->settingManager->initSetting($this, self::SEM_RANKING_POS_X, 110);
		$this->maniaControl->settingManager->initSetting($this, self::SEM_RANKING_POS_Y, 50);
		$this->maniaControl->settingManager->initSetting($this, self::SEM_RANKING_SCALE, 1);
		
		// IGNORED_PLAYERS_LIST Setting
		$this->maniaControl->settingManager->initSetting($this, self::IGNORED_PLAYERS_LIST, 'wellef;login1;login2;...');
		
		// RESET_ON_NEW_ROUND Setting
		$this->maniaControl->settingManager->initSetting($this, self::RESET_ON_NEW_ROUND, false);
		
		// PLAYER_CONNECTED Settings
		$this->maniaControl->settingManager->initSetting($this, self::ENABLE_PLAYER_CONNECTED_SOUND, false);
		$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_PLAYER_CONNECTED, '');
		
		// PLAYER_DISCONNECTED Settings
		$this->maniaControl->settingManager->initSetting($this, self::ENABLE_PLAYER_DISCONNECTED_SOUND, false);
		$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_PLAYER_DISCONNECTED, '');
		
		// BEGIN_MAP : allow and link
		$this->maniaControl->settingManager->initSetting($this, self::ENABLE_BEGIN_MAP_SOUND, false);
		$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_BEGIN_MAP, '');
		
		// BEGIN_PLAYING : allow and link
		$this->maniaControl->settingManager->initSetting($this, self::ENABLE_BEGIN_PLAYING_SOUND, true);
		$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_BEGIN_PLAYING, $rep_sounds . 'prepare.wav');
		
		// BLUE/RED TEAM SCORES : allow and links
		$this->maniaControl->settingManager->initSetting($this, self::ENABLE_TEAM_SCORES_SOUND, true);
		$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_BLUE_TEAM_SCORES, $rep_sounds . 'Blue_Team_Scores.wav');
		$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_RED_TEAM_SCORES, $rep_sounds . 'Red_Team_Scores.wav');
				
		// BACKSPACE : allow and link
		$this->maniaControl->settingManager->initSetting($this, self::ENABLE_BACKSPACE_SOUND, true);
		$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_BACKSPACE, $rep_sounds . 'ReturnSound.wav');
		
		// OFFZONE : allow and link
		$this->maniaControl->settingManager->initSetting($this, self::ENABLE_OFFZONE_SOUND, true);
		$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_OFFZONE, $rep_sounds . 'humiliation.wav');
		
		// HIT : allow and link
		$this->maniaControl->settingManager->initSetting($this, self::ENABLE_HIT_SOUND, false);
		$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_HIT, '');
		
		// TEAMKILLER : allow and link
		$this->maniaControl->settingManager->initSetting($this, self::ENABLE_TEAMKILLER_SOUND, false);
		$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_TEAMKILLER, $rep_sounds . 'teamkiller.wav');
		
		// KILL AWARDS : allow
		$this->maniaControl->settingManager->initSetting($this, self::ENABLE_KILL_AWARDS, true);
		
		// MODE specific
		switch ($mode) {
			// SpeedBall default config
			case 'SpeedBall@steeffeen': {
				// TEAMKILLER : allow and link
				$this->maniaControl->settingManager->initSetting($this, self::ENABLE_TEAMKILLER_SOUND, true);
				
				// KILL AWARDS : links
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_01, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_02, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_03, $rep_sounds . 'dominating.wav   ');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_04, $rep_sounds . 'rampage.wav      ');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_05, $rep_sounds . 'killingspree.wav ');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_06, $rep_sounds . 'ultrakill.wav    ');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_07, $rep_sounds . 'wickedsick.wav   ');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_08, $rep_sounds . 'monsterkill.wav  ');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_09, $rep_sounds . 'unstoppable.wav  ');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_10, $rep_sounds . 'godlike.wav      ');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_11, $rep_sounds . 'holyshit.wav     ');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_12, $rep_sounds . 'LudicrousKill.wav');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_13, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_14, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_15, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_16, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_17, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_18, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_19, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_20, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_21, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_22, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_23, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_24, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_25, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_26, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_27, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_28, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_29, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_30, '');
				break;
			}
			case 'SMStormSiege@nadeolabs': {
				// BLUE/RED TEAM SCORES : allow
				$this->maniaControl->settingManager->initSetting($this, self::ENABLE_TEAM_SCORES_SOUND, false);
				
				// RESET_ON_NEW_ROUND Setting
				$this->maniaControl->settingManager->initSetting($this, self::RESET_ON_NEW_ROUND, true);
				
				// KILL AWARDS : links
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_01, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_02, $rep_sounds . 'dominating.wav   ');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_03, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_04, $rep_sounds . 'rampage.wav      ');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_05, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_06, $rep_sounds . 'killingspree.wav ');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_07, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_08, $rep_sounds . 'ultrakill.wav    ');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_09, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_10, $rep_sounds . 'wickedsick.wav   ');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_11, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_12, $rep_sounds . 'monsterkill.wav  ');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_13, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_14, $rep_sounds . 'unstoppable.wav  ');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_15, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_16, $rep_sounds . 'godlike.wav      ');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_17, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_18, $rep_sounds . 'holyshit.wav     ');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_19, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_20, $rep_sounds . 'LudicrousKill.wav');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_21, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_22, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_23, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_24, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_25, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_26, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_27, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_28, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_29, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_30, '');
				break;
			}
			default: {
				// KILL AWARDS : links
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_01, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_02, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_03, $rep_sounds . 'dominating.wav   ');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_04, $rep_sounds . 'rampage.wav      ');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_05, $rep_sounds . 'killingspree.wav ');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_06, $rep_sounds . 'ultrakill.wav    ');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_07, $rep_sounds . 'wickedsick.wav   ');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_08, $rep_sounds . 'monsterkill.wav  ');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_09, $rep_sounds . 'unstoppable.wav  ');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_10, $rep_sounds . 'godlike.wav      ');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_11, $rep_sounds . 'holyshit.wav     ');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_12, $rep_sounds . 'LudicrousKill.wav');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_13, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_14, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_15, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_16, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_17, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_18, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_19, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_20, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_21, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_22, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_23, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_24, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_25, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_26, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_27, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_28, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_29, '');
				$this->maniaControl->settingManager->initSetting($this, self::SOUND_LINK_KILL_30, '');
				break;
			}
		}
		
		// SERVER specific
		/*
		switch ($serverName) {
			// SpeedBall default config
			case 'mm2monde.fr': {
				// ENABLE_TEAM_SCORES_SOUND = false
				//$this->maniaControl->settingManager->initSetting($this, self::ENABLE_TEAM_SCORES_SOUND, false);
				break;
			}
			case 'TO DO': {
				// BLUE/RED TEAM SCORES : allow
				//$this->maniaControl->settingManager->initSetting($this, self::ENABLE_TEAM_SCORES_SOUND, false);
				break;
			}
			default: {
				// BLUE/RED TEAM SCORES : allow
				//$this->maniaControl->settingManager->initSetting($this, self::ENABLE_TEAM_SCORES_SOUND, true);
				break;
			}
		}
		*/
		
		// SETTINGS TO DELETE (when i've changed their value)
		$this->maniaControl->settingManager->deleteSetting($this, '00b1. MUSIC enabled ?');
		
		// ICONS for MENU
		$this->maniaControl->manialinkManager->getIconManager()->addIcon(self::SEM_ICON_MENU				, self::SEM_ICON_MENU_PATH       );
		$this->maniaControl->manialinkManager->getIconManager()->addIcon(self::SEM_ICON_MENU_MOVER			, self::SEM_ICON_MENU_MOVER_PATH );
		
		// ICONS for SOUNDS
		$this->maniaControl->manialinkManager->registerManialinkPageAnswerListener(self::ML_ICON_SOUND_ID, $this, 'enable_disable_sounds');
		$this->maniaControl->manialinkManager->getIconManager()->addIcon(self::SEM_ICON_SOUND_ON			, self::SEM_ICON_SOUND_ON_PATH       );
		$this->maniaControl->manialinkManager->getIconManager()->addIcon(self::SEM_ICON_SOUND_ON_MOVER		, self::SEM_ICON_SOUND_ON_MOVER_PATH );
		$this->maniaControl->manialinkManager->getIconManager()->addIcon(self::SEM_ICON_SOUND_OFF			, self::SEM_ICON_SOUND_OFF_PATH      );
		$this->maniaControl->manialinkManager->getIconManager()->addIcon(self::SEM_ICON_SOUND_OFF_MOVER		, self::SEM_ICON_SOUND_OFF_MOVER_PATH);
		
		// ICONS for MESSAGES
		$this->maniaControl->manialinkManager->registerManialinkPageAnswerListener(self::ML_ICON_MESSAGE_ID, $this, 'enable_disable_messages');
		$this->maniaControl->manialinkManager->getIconManager()->addIcon(self::SEM_ICON_MESSAGE_ON			, self::SEM_ICON_MESSAGE_ON_PATH       );
		$this->maniaControl->manialinkManager->getIconManager()->addIcon(self::SEM_ICON_MESSAGE_ON_MOVER	, self::SEM_ICON_MESSAGE_ON_MOVER_PATH );
		$this->maniaControl->manialinkManager->getIconManager()->addIcon(self::SEM_ICON_MESSAGE_OFF			, self::SEM_ICON_MESSAGE_OFF_PATH      );
		$this->maniaControl->manialinkManager->getIconManager()->addIcon(self::SEM_ICON_MESSAGE_OFF_MOVER	, self::SEM_ICON_MESSAGE_OFF_MOVER_PATH);
		
		// ICONS for RANKING
		$this->maniaControl->manialinkManager->registerManialinkPageAnswerListener(self::ML_ICON_RANKING_ID, $this, 'enable_disable_ranking');
		$this->maniaControl->manialinkManager->getIconManager()->addIcon(self::SEM_ICON_RANKING_ON			, self::SEM_ICON_RANKING_ON_PATH       );
		$this->maniaControl->manialinkManager->getIconManager()->addIcon(self::SEM_ICON_RANKING_ON_MOVER	, self::SEM_ICON_RANKING_ON_MOVER_PATH );
		$this->maniaControl->manialinkManager->getIconManager()->addIcon(self::SEM_ICON_RANKING_OFF			, self::SEM_ICON_RANKING_OFF_PATH      );
		$this->maniaControl->manialinkManager->getIconManager()->addIcon(self::SEM_ICON_RANKING_OFF_MOVER	, self::SEM_ICON_RANKING_OFF_MOVER_PATH);
		
		// ICONS for MUSIC
		$this->maniaControl->manialinkManager->registerManialinkPageAnswerListener(self::ML_ICON_MUSIC_ID, $this, 'enable_disable_music');
		$this->maniaControl->manialinkManager->getIconManager()->addIcon(self::SEM_ICON_MUSIC_ON			, self::SEM_ICON_MUSIC_ON_PATH       );
		$this->maniaControl->manialinkManager->getIconManager()->addIcon(self::SEM_ICON_MUSIC_ON_MOVER		, self::SEM_ICON_MUSIC_ON_MOVER_PATH );
		$this->maniaControl->manialinkManager->getIconManager()->addIcon(self::SEM_ICON_MUSIC_OFF			, self::SEM_ICON_MUSIC_OFF_PATH      );
		$this->maniaControl->manialinkManager->getIconManager()->addIcon(self::SEM_ICON_MUSIC_OFF_MOVER		, self::SEM_ICON_MUSIC_OFF_MOVER_PATH);
		
		// Global variable for music
		$this->musicEnabled = $this->maniaControl->settingManager->getSettingValue($this, self::MUSIC_ENABLE);
		// Music to play ?
		$this->musicToPlay();
		
		// Add icons to menu for each player
		$this->addMenuIconToAll();
		
    }
	
	
	
	/**
	 * Display the Menu Icons for SEM to everybody
	 *
	 */
	public function addMenuIconToAll() {
		// Display the SEM icons only for non-ignored players
		foreach ($this->maniaControl->getPlayerManager()->getPlayers() as $player) {
			if (!$this->isIgnored($player->login)) {
				$this->addMenuIcon($player);
			}
		}
	}
	
	/**
	 * Display the SEM Menu Icons for $player
	 *
	 * Mainly copy/paste from displayDonateWidget() in DonationPlugin.php
	 *
	 */
	public function addMenuIcon($player) {
		$posX              = $this->maniaControl->getSettingManager()->getSettingValue($this, self::SEM_ICON_MENU_POS_X);
		$posY              = $this->maniaControl->getSettingManager()->getSettingValue($this, self::SEM_ICON_MENU_POS_Y);
		$scale             = 0.9;
		$width             = 6;
		$height            = 6;
		$shootManiaOffset  = $this->maniaControl->getManialinkManager()->getStyleManager()->getDefaultIconOffsetSM();
		$quadStyle         = $this->maniaControl->getManialinkManager()->getStyleManager()->getDefaultQuadStyle();
		$quadSubstyle      = $this->maniaControl->getManialinkManager()->getStyleManager()->getDefaultQuadSubstyle();
		$itemMarginFactorX = 1.3;
		$itemMarginFactorY = 1.2;
		$itemNumber        = 4;
		
		//If game is shootmania lower the icons position by 20
		if ($this->maniaControl->getMapManager()->getCurrentMap()->getGame() === 'sm') {
			$posY -= $shootManiaOffset;
		}
		
		$itemSize = $width;

		$maniaLink = new ManiaLink(self::ML_ICON_MENU_ID);
		
		// Setting player's lvariables
		$playerLogin = $player->login;
		
		// Need to send ManiaLink to everybody ?
		$sendMLToAll = false;
		
		// SEM MENU ICON FRAME
		$frame = new Frame();
		$maniaLink->add($frame);
		$frame->setPosition($posX, $posY);

		$backgroundQuad = new Quad();
		$frame->add($backgroundQuad);
		$backgroundQuad->setSize($width * $itemMarginFactorX, $height * $itemMarginFactorY);
		$backgroundQuad->setStyles($quadStyle, $quadSubstyle);

		$iconFrame = new Frame();
		$frame->add($iconFrame);

		/*
		$iconFrame->setSize($itemSize, $itemSize);
		$itemQuad = new Quad_BgRaceScore2();
		$itemQuad->setSubStyle($itemQuad::SUBSTYLE_Points);
		$itemQuad->setSize($itemSize, $itemSize);
		$iconFrame->add($itemQuad);
		*/
		
		// "SEM" ICON
		$iconFrame->setSize($itemSize, $itemSize);
		$itemQuad = new Quad();
		$itemQuad->setImage($this->maniaControl->manialinkManager->getIconManager()->getIcon(self::SEM_ICON_MENU));
		$itemQuad->setImageFocus($this->maniaControl->manialinkManager->getIconManager()->getIcon(self::SEM_ICON_MENU_MOVER));
		$itemQuad->setSize($itemSize, $itemSize);
		$iconFrame->add($itemQuad);
		
		// POPUP MENU
		$popoutFrame = new Frame();
		$maniaLink->add($popoutFrame);
		$popoutFrame->setPosition($posX - $itemSize * 0.5, $posY);
		$popoutFrame->setHAlign($popoutFrame::RIGHT);
		$popoutFrame->setSize($itemSize * $itemMarginFactorX * $itemNumber, $itemSize * $itemMarginFactorY);
		$popoutFrame->setVisible(false);
		
		$quad = new Quad();
		$popoutFrame->add($quad);
		$quad->setHAlign($quad::RIGHT);
		$quad->setStyles($quadStyle, $quadSubstyle);
		$quad->setSize($itemSize * $itemMarginFactorX * $itemNumber, $itemSize * $itemMarginFactorY);
		
		$popoutFrame->add($quad);
		$itemQuad->addToggleFeature($popoutFrame);
		
		// DESCRIPTION LABEL
		$descriptionFrame = new Frame();
		$maniaLink->add($descriptionFrame);
		$descriptionFrame->setPosition($posX - $itemSize * $itemMarginFactorX * $itemNumber * 1.1, $posY);
		$descriptionFrame->setHAlign($descriptionFrame::RIGHT);

		$descriptionLabel = new Label();
		$descriptionFrame->add($descriptionLabel);
		$descriptionLabel->setAlign($descriptionLabel::RIGHT, $descriptionLabel::TOP);
		$descriptionLabel->setSize(20, 2);
		$descriptionLabel->setTextSize(1);
		$descriptionLabel->setVisible(true);
		$descriptionLabel->setTextColor('fff');
		
		// SOUNDS ICON
		if ($this->hasDisabledSounds($playerLogin)) {
			// Add the "enable" button
			$itemQuadSound = new Quad();
			$popoutFrame->add($itemQuadSound);
			$itemQuadSound->setPosition($itemSize * -1, 0);
			$itemQuadSound->setSize($itemSize * $scale, $itemSize * $scale);
			$itemQuadSound->setImage($this->maniaControl->manialinkManager->getIconManager()->getIcon(self::SEM_ICON_SOUND_ON));
			$itemQuadSound->setImageFocus($this->maniaControl->manialinkManager->getIconManager()->getIcon(self::SEM_ICON_SOUND_ON_MOVER));
			$itemQuadSound->setAction(self::ML_ICON_SOUND_ID);
			$itemQuadSound->addTooltipLabelFeature($descriptionLabel, "Enable sounds");
		} else {
			// Add the "disable" button
			$itemQuadSound = new Quad();
			$popoutFrame->add($itemQuadSound);
			$itemQuadSound->setPosition($itemSize * -1, 0);
			$itemQuadSound->setSize($itemSize * $scale, $itemSize * $scale);
			$itemQuadSound->setImage($this->maniaControl->manialinkManager->getIconManager()->getIcon(self::SEM_ICON_SOUND_OFF));
			$itemQuadSound->setImageFocus($this->maniaControl->manialinkManager->getIconManager()->getIcon(self::SEM_ICON_SOUND_OFF_MOVER));
			$itemQuadSound->setAction(self::ML_ICON_SOUND_ID);
			$itemQuadSound->addTooltipLabelFeature($descriptionLabel, "Disable sounds");
		}
		
		// RANKING ICON
		if ($this->hasDisabledRanking($playerLogin)) {
			// Add the "enable" button
			$itemQuadRanking = new Quad();
			$popoutFrame->add($itemQuadRanking);
			$itemQuadRanking->setPosition($itemSize * -2, 0);
			$itemQuadRanking->setSize($itemSize * $scale, $itemSize * $scale);
			$itemQuadRanking->setImage($this->maniaControl->manialinkManager->getIconManager()->getIcon(self::SEM_ICON_RANKING_ON));
			$itemQuadRanking->setImageFocus($this->maniaControl->manialinkManager->getIconManager()->getIcon(self::SEM_ICON_RANKING_ON_MOVER));
			$itemQuadRanking->setAction(self::ML_ICON_RANKING_ID);
			$itemQuadRanking->addTooltipLabelFeature($descriptionLabel, "Enable ranking");
		} else {
			// Add the "disable" button
			$itemQuadRanking = new Quad();
			$popoutFrame->add($itemQuadRanking);
			$itemQuadRanking->setPosition($itemSize * -2, 0);
			$itemQuadRanking->setSize($itemSize * $scale, $itemSize * $scale);
			$itemQuadRanking->setImage($this->maniaControl->manialinkManager->getIconManager()->getIcon(self::SEM_ICON_RANKING_OFF));
			$itemQuadRanking->setImageFocus($this->maniaControl->manialinkManager->getIconManager()->getIcon(self::SEM_ICON_RANKING_OFF_MOVER));
			$itemQuadRanking->setAction(self::ML_ICON_RANKING_ID);
			$itemQuadRanking->addTooltipLabelFeature($descriptionLabel, "Disable ranking");
		}
		
		// MESSAGES ICON
		if ($this->hasDisabledMessages($playerLogin)) {
			// Add the "enable" button
			$itemQuadMessages = new Quad();
			$popoutFrame->add($itemQuadMessages);
			$itemQuadMessages->setPosition($itemSize * -3, 0);
			$itemQuadMessages->setSize($itemSize * $scale, $itemSize * $scale);
			$itemQuadMessages->setImage($this->maniaControl->manialinkManager->getIconManager()->getIcon(self::SEM_ICON_MESSAGE_ON));
			$itemQuadMessages->setImageFocus($this->maniaControl->manialinkManager->getIconManager()->getIcon(self::SEM_ICON_MESSAGE_ON_MOVER));
			$itemQuadMessages->setAction(self::ML_ICON_MESSAGE_ID);
			$itemQuadMessages->addTooltipLabelFeature($descriptionLabel, "Enable messages");
		} else {
			// Add the "disable" button
			$itemQuadMessages = new Quad();
			$popoutFrame->add($itemQuadMessages);
			$itemQuadMessages->setPosition($itemSize * -3, 0);
			$itemQuadMessages->setSize($itemSize * $scale, $itemSize * $scale);
			$itemQuadMessages->setImage($this->maniaControl->manialinkManager->getIconManager()->getIcon(self::SEM_ICON_MESSAGE_OFF));
			$itemQuadMessages->setImageFocus($this->maniaControl->manialinkManager->getIconManager()->getIcon(self::SEM_ICON_MESSAGE_OFF_MOVER));
			$itemQuadMessages->setAction(self::ML_ICON_MESSAGE_ID);
			$itemQuadMessages->addTooltipLabelFeature($descriptionLabel, "Disable messages");
		}
		
		// MUSIC ICON
		// Display music icon only for ADMIN or greater
		if ($this->maniaControl->getAuthenticationManager()->checkRight($player, AuthenticationManager::AUTH_LEVEL_ADMIN)) {
			// New music icon needs to be displayed to all admins (so to everybody)
			$sendMLToAll = true;
			if ($this->musicEnabled) {
				// Add the "disable" button
				$itemQuadMusic = new Quad();
				$popoutFrame->add($itemQuadMusic);
				$itemQuadMusic->setPosition($itemSize * -4, 0);
				$itemQuadMusic->setSize($itemSize * $scale, $itemSize * $scale);
				$itemQuadMusic->setImage($this->maniaControl->manialinkManager->getIconManager()->getIcon(self::SEM_ICON_MUSIC_OFF));
				$itemQuadMusic->setImageFocus($this->maniaControl->manialinkManager->getIconManager()->getIcon(self::SEM_ICON_MUSIC_OFF_MOVER));
				$itemQuadMusic->setAction(self::ML_ICON_MUSIC_ID);
				$itemQuadMusic->addTooltipLabelFeature($descriptionLabel, "Stop music");
			} else {
				// Add the "enable" button
				$itemQuadMusic = new Quad();
				$popoutFrame->add($itemQuadMusic);
				$itemQuadMusic->setPosition($itemSize * -4, 0);
				$itemQuadMusic->setSize($itemSize * $scale, $itemSize * $scale);
				$itemQuadMusic->setImage($this->maniaControl->manialinkManager->getIconManager()->getIcon(self::SEM_ICON_MUSIC_ON));
				$itemQuadMusic->setImageFocus($this->maniaControl->manialinkManager->getIconManager()->getIcon(self::SEM_ICON_MUSIC_ON_MOVER));
				$itemQuadMusic->setAction(self::ML_ICON_MUSIC_ID);
				$itemQuadMusic->addTooltipLabelFeature($descriptionLabel, "Play music");
			}
		}
		
		
		// Send ManiaLink to everybody
		if ($sendMLToAll) {
			$this->sendManiaLink($maniaLink, null, 'icon');
		}
		// Send ManiaLink only to $player
		else {
			$this->sendManiaLink($maniaLink, $playerLogin, 'icon');
		}
	}
	
	/*
	 * Remove the Menu Icons
	 */
	public function removeMenuIcon() {
		$this->maniaControl->getManialinkManager()->hideManialink(self::ML_ICON_MENU_ID);
	}
	
	
	
	
	/**
	 * Function handling the pressing of the SOUND icon, to activate/desactive sounds
	 *
	 * @param array  $chatCallback
	 * @param Player $player
	 */
	public function enable_disable_sounds(array $chatCallback, Player $player) {
		$playerLogin = $player->login;
		
		// Add or remove the player from the "disabledSoundsPlayers" list
		if ($this->hasDisabledSounds($playerLogin)) {
			// Sending message to player
			$this->maniaControl->getChat()->sendInformation('[Sound Events Manager] Sounds enabled.', $playerLogin, false);
			// Remove player
			unset($this->disabledSoundsPlayers[$playerLogin]);
		}
		else {
			// Sending message to player
			$this->maniaControl->getChat()->sendInformation('[Sound Events Manager] Sounds disabled.', $playerLogin, false);
			// Add player
			$this->disabledSoundsPlayers[$playerLogin] = $playerLogin;
		}
		
		// Update Menu Icons
		$this->addMenuIcon($player);
	}
	
	
	
	/**
	 * Function handling the pressing of the MESSAGE icon, to activate/desactive messages
	 *
	 * @param array  $chatCallback
	 * @param Player $player
	 */
	public function enable_disable_messages(array $chatCallback, Player $player) {
		$playerLogin = $player->login;
		
		// Add or remove the player from the "disabledMessagesPlayers" list
		if ($this->hasDisabledMessages($playerLogin)) {
			// Sending message to player
			$this->maniaControl->getChat()->sendInformation('[Sound Events Manager] Messages enabled.', $playerLogin, false);
			// Remove player
			unset($this->disabledMessagesPlayers[$playerLogin]);
		}
		else {
			// Sending message to player
			$this->maniaControl->getChat()->sendInformation('[Sound Events Manager] Messages disabled.', $playerLogin, false);
			// Add player
			$this->disabledMessagesPlayers[$playerLogin] = $playerLogin;
		}
		
		// Update Menu Icons
		$this->addMenuIcon($player);
	}
	
	
	
	/**
	 * Function handling the pressing of the RANKING icon, to activate/desactive ranking
	 *
	 * @param array  $chatCallback
	 * @param Player $player
	 */
	public function enable_disable_ranking(array $chatCallback, Player $player) {
		$playerLogin = $player->login;
		
		// Add or remove the player from the "disabledRankingPlayers" list
		if ($this->hasDisabledRanking($playerLogin)) {
			// Sending message to player
			$this->maniaControl->getChat()->sendInformation('[Sound Events Manager] Ranking enabled.', $playerLogin, false);
			// Remove player
			unset($this->disabledRankingPlayers[$playerLogin]);
		}
		else {
			// Sending message to player
			$this->maniaControl->getChat()->sendInformation('[Sound Events Manager] Ranking disabled.', $playerLogin, false);
			// Add player
			$this->disabledRankingPlayers[$playerLogin] = $playerLogin;
		}
		
		// Update Menu Icons
		$this->addMenuIcon($player);
	}
	
	
	
	/**
	 * Function handling the pressing of the MUSIC icon, to activate/desactive music
	 *
	 * @param array  $chatCallback
	 * @param Player $player
	 */
	public function enable_disable_music(array $chatCallback, Player $player) {
		
		if ($this->musicEnabled == true) {
			// Sending message to everyone
			$this->maniaControl->getChat()->sendInformation('[Sound Events Manager] Music stopped.', null, false);
			// Stop playing the music
			$this->stopMusic();
			// Music is now enabled
			$this->musicEnabled = false;
		}
		else {
			// Sending message to everyone
			$this->maniaControl->getChat()->sendInformation('[Sound Events Manager] Playing music.', null, false);
			// Start playing the music
			$this->playMusic();
			// Music is now disabled
			$this->musicEnabled = true;
		}
		
		// Update Menu Icons
		$this->addMenuIcon($player);
	}
	
	
	
	/*
	 * Check if a sound should be played. If so, plays that sound.
	 */
	public function soundToPlay($allowed, $link, $authorLogin) {
		$SOUND_ALLOWED	= $this->maniaControl->settingManager->getSettingValue($this, $allowed);
		$SOUND_LINK		= $this->maniaControl->settingManager->getSettingValue($this, $link);
		
		// Play sounds only if ALLOWED and LINK available and PLAYER NOT IGNORED
		if ($SOUND_ALLOWED == true && !empty($SOUND_LINK)) {
			$rc = $this->playSound($SOUND_LINK, $authorLogin);
			return $rc;
		}
		else { return false; }
	}
	
	/*
	 * Plays the sound "$link" if able
	 *
	 * Returns true if a sound has been played, false otherwise
	 *
	 */
	public function playSound($link, $authorLogin) {
		$VOLUME	= $this->maniaControl->settingManager->getSettingValue($this, self::VOLUME);
		
		// DEBUG 
		//$this->toLog("link=$link / authorLogin=$authorLogin / VOLUME=$VOLUME");
		
		// Don't play sounds if $link doesn't exist or author of sound is IGNORED
		if (empty($link) || $this->isIgnored($authorLogin)) { return false; }
		
		// Create an audio element to play a sound with the FML
		$maniaLink = new \FML\ManiaLink(self::ML_SOUND_ID);
		$audio = new \FML\Controls\Audio();
		$maniaLink->add($audio);
		$audio->setVolume($VOLUME);		//						  from FML/Types/Playable.php
		$audio->setPlay(1);				// Play automatically	- from FML/Types/Playable.php
		$audio->setLooping(0);			// Play only once		- from FML/Types/Playable.php
		$audio->setVisible(0);			// Popup not visible	- from FML/Controls/Control.php
		$audio->setData($link);
		
		// Send ManiaLink
		$this->sendManiaLink($maniaLink, null, 'sound');
		
		return true;
	}
	
	
	
	/**
	 * Display a message during a delay
	 *
	 */
	public function showMessage($message, $authorLogin) {
		// Remove the previous timer listener to keep the delay before removing the message
        $this->maniaControl->timerManager->unregisterTimerListening($this, 'removeMessage');
		
		// Don't display message if author of sound is IGNORED
		if ($this->isIgnored($authorLogin)) { return false; }
		
		$maniaLink = new ManiaLink(self::ML_MESSAGE_ID);

		// Main frame
		$frame = new Frame();
		$maniaLink->add($frame);
		$xPos	= $this->maniaControl->settingManager->getSettingValue($this, self::SEM_MESSAGES_POS_X);
		$yPos	= $this->maniaControl->settingManager->getSettingValue($this, self::SEM_MESSAGES_POS_Y);
		$scale	= $this->maniaControl->settingManager->getSettingValue($this, self::SEM_MESSAGES_SCALE);
		$frame->setPosition($xPos, $yPos, 0);

		// Background
		$backgroundQuad = new Quad();
		$frame->add($backgroundQuad);
		
		// Message
		$messageLabel = new Label_Button();
		$frame->add($messageLabel);
		$messageLabel->setScale($scale);
		$messageLabel->setText($message);
		$messageLabel->setStyle(Label_Text::STYLE_TextStaticSmall);
		
		// Send ManiaLink
		$this->sendManiaLink($maniaLink, null, 'message');
		
		// Remove the message after a delay
		$this->maniaControl->timerManager->registerOneTimeListening($this, 'removeMessage', 3000);
	}
	
	/*
	 * Remove the message
	 */
	public function removeMessage() {
		$this->maniaControl->manialinkManager->hideManialink(self::ML_MESSAGE_ID);
	}
	
	
	
	/**
	 * Popup a widget with the killstreak ranking of 3 best players
	 */
	public function showRanking($killStreak_1_player, $killStreak_1_score, $killStreak_2_player, $killStreak_2_score, $killStreak_3_player, $killStreak_3_score) {
		// Remove the widget
		$this->maniaControl->manialinkManager->hideManialink(self::ML_RANKING_ID);
		
		// Check if there's at least 1 ranking to display
		if ($killStreak_1_player == null) { return; }
		
		$maniaLink = new ManiaLink(self::ML_RANKING_ID);

		// Main frame
		$frame = new Frame();
		$maniaLink->add($frame);
		$xPos	= $this->maniaControl->settingManager->getSettingValue($this, self::SEM_RANKING_POS_X);
		$yPos	= $this->maniaControl->settingManager->getSettingValue($this, self::SEM_RANKING_POS_Y);
		$scale	= $this->maniaControl->settingManager->getSettingValue($this, self::SEM_RANKING_SCALE);
		$frame->setPosition($xPos, $yPos, 0);

		// Background
		$backgroundQuad = new Quad();
		$frame->add($backgroundQuad);
		
		// Ranking
		/*
		$messageLabel_0 = new Label_Button();
		$frame->add($messageLabel_0);
		$messageLabel_0->setPosition(1, 1, 1);
		$messageLabel_0->setScale($scale);
		$messageLabel_0->setAlign('left', 'center');
		$messageLabel_0->setText('$b$fff RANKING');
		$messageLabel_0->setStyle(Label_Text::STYLE_TextStaticSmall);
		*/
		
		// Ranking 1
		$killStreak_1_player_nickname = $this->maniaControl->getPlayerManager()->getPlayer($killStreak_1_player)->nickname;
		$messageLabel_1 = new Label_Button();
		$frame->add($messageLabel_1);
		$messageLabel_1->setPosition(1, -5, 2);
		$messageLabel_1->setScale($scale);
		$messageLabel_1->setAlign('left', 'center');
		$messageLabel_1->setText($killStreak_1_player_nickname . '$z$s$fff : ' . $killStreak_1_score . ' frags');
		$messageLabel_1->setStyle(Label_Text::STYLE_TextStaticSmall);
		
		// Ranking 2
		if ($killStreak_2_player !== null) {
			$killStreak_2_player_nickname = $this->maniaControl->getPlayerManager()->getPlayer($killStreak_2_player)->nickname;
			$messageLabel_2 = new Label_Button();
			$frame->add($messageLabel_2);
			$messageLabel_2->setPosition(1, -10, 3);
			$messageLabel_2->setScale($scale);
			$messageLabel_2->setAlign('left', 'center');
			$messageLabel_2->setText($killStreak_2_player_nickname . '$z$s$fff : ' . $killStreak_2_score . ' frags');
			$messageLabel_2->setStyle(Label_Text::STYLE_TextStaticSmall);
		}
		
		// Ranking 3
		if ($killStreak_3_player !== null) {
			$killStreak_3_player_nickname = $this->maniaControl->getPlayerManager()->getPlayer($killStreak_3_player)->nickname;
			$messageLabel_3 = new Label_Button();
			$frame->add($messageLabel_3);
			$messageLabel_3->setPosition(1, -15, 4);
			$messageLabel_3->setScale($scale);
			$messageLabel_3->setAlign('left', 'center');
			$messageLabel_3->setText($killStreak_3_player_nickname . '$z$s$fff : ' . $killStreak_3_score . ' frags');
			$messageLabel_3->setStyle(Label_Text::STYLE_TextStaticSmall);
		}
		
		// Send ManiaLink
		$this->sendManiaLink($maniaLink, null, 'ranking');
	}
	
	
	
	/*
	 * Check if music should be played. If so, plays the music.
	 */
	public function musicToPlay() {
		$MUSIC_ENABLE = $this->maniaControl->settingManager->getSettingValue($this, self::MUSIC_ENABLE);
		if ($MUSIC_ENABLE) { $this->playMusic(); }
	}
	
	/*
	 * Plays music in loop
	 *
	 */
	public function playMusic() {
		$MUSIC_VOLUME	= $this->maniaControl->settingManager->getSettingValue($this, self::MUSIC_VOLUME);
		$MUSIC_LINK		= $this->maniaControl->settingManager->getSettingValue($this, self::MUSIC_LINK);
		
		// DEBUG
		// $this->toLog("Playing music $MUSIC_LINK with VOLUME $MUSIC_VOLUME");
		
		// Don't play sounds if $MUSIC_LINK doesn't exist
		if (empty($MUSIC_LINK)) { return; }
		
		// Create an audio element to play a sound with the FML
		$maniaLink = new \FML\ManiaLink(self::ML_MUSIC_ID);
		$audio = new \FML\Controls\Audio();
		$maniaLink->add($audio);
		$audio->setVolume($MUSIC_VOLUME);	//						  from FML/Types/Playable.php
		$audio->setPlay(1);					// Play automatically	- from FML/Types/Playable.php
		$audio->setLooping(1);				// Play in loop			- from FML/Types/Playable.php
		$audio->setVisible(0);				// Popup not visible	- from FML/Controls/Control.php
		//$audio->setMusic($MUSIC_LINK);	// KO
		$audio->setData($MUSIC_LINK);
		
		// Send ManiaLink
		$this->sendManiaLink($maniaLink, null, 'sound');
	}
	
	/*
	 * Stop the music
	 */
	public function stopMusic() {
		$this->maniaControl->manialinkManager->hideManialink(self::ML_MUSIC_ID);
	}
	
	
	
	/**
	 * Send a ManiaLink to $login if setted, to all players allowed otherwise
	 */
	public function sendManiaLink($maniaLink, $login, $type) {
		// DEBUG
		//$this->toLog("Sending ManiaLink : $maniaLink");
		
		// Sending ManiaLink to only one player
		if (!is_null($login)) {
			// Send ManiaLink only to non-ignored players and if type of ManiaLink is not disabled for this player
			if (!$this->isIgnored($login) && !$this->hasDisabledFromType($login, $type)) {
				$this->maniaControl->manialinkManager->sendManialink($maniaLink,$login);
			}
		}
		// Sending ManiaLink to all players allowed
		else {
			// Send ManiaLink only to non-ignored players and if type of ManiaLink is not disabled for this player
			foreach ($this->maniaControl->getPlayerManager()->getPlayers() as $player) {
				$playerLogin = $player->login;
				if (!$this->isIgnored($playerLogin) && !$this->hasDisabledFromType($playerLogin, $type)) {
					$this->maniaControl->manialinkManager->sendManialink($maniaLink,$playerLogin);
				}
			}
		}
	}
	
	
	
	/*
	 * Return true is $login is ignored, false otherwise.
	 */
	public function isIgnored($login) {
		// Stop if there's no $login
		if ($login == null) { return false; }
		
		// Get ignore list
		$IGNORED_PLAYERS_LIST	= $this->maniaControl->settingManager->getSettingValue($this, self::IGNORED_PLAYERS_LIST);
		
		// Get the list of ignored players in an array
		$listeOfIgnoredPlayers = array();
		if (!empty($IGNORED_PLAYERS_LIST)) { $listeOfIgnoredPlayers = explode(";", $IGNORED_PLAYERS_LIST); }
		
		// Return if $login is ignored
		if (!empty($listeOfIgnoredPlayers) && in_array($login, $listeOfIgnoredPlayers)) { return true; }
		else { return false; }
	}
	
	/*
	 * Return true is $login has disabled $type, false otherwise.
	 */
	public function hasDisabledFromType($login, $type) {
		$hasDisabledType = false;
		switch ($type) {
			case 'sound': {
				if ($this->hasDisabledSounds($login)) { $hasDisabledType = true; }
				break;
			}
			case 'ranking': {
				if ($this->hasDisabledRanking($login)) { $hasDisabledType = true; }
				break;
			}
			case 'message': {
				if ($this->hasDisabledMessages($login)) { $hasDisabledType = true; }
				break;
			}
			case 'icon': {
				// Always allow icons. Can't activate/desactive SEM without it.
				$hasDisabledType = false;
				break;
			}
		}
		return $hasDisabledType;
	}
	
	/*
	 * Return true is $login has disabled plugin, false otherwise.
	 */
	public function hasDisabledSounds($login) {
		if (in_array($login, $this->disabledSoundsPlayers)) { return true; }
		else { return false; }
	}
	
	/*
	 * Return true is $login has disabled ranking, false otherwise.
	 */
	public function hasDisabledRanking($login) {
		if (in_array($login, $this->disabledRankingPlayers)) { return true; }
		else { return false; }
	}
	
	/*
	 * Return true is $login has disabled messages, false otherwise.
	 */
	public function hasDisabledMessages($login) {
		if (in_array($login, $this->disabledMessagesPlayers)) { return true; }
		else { return false; }
	}
	
	
	
	/**
	 * Function handling on the connection of a player.
	 *
	 * @param Player $player
	 */
	public function handlePlayerConnect(Player $player) {
		$login = $player->login;
		// Initialization of the player connected
		$this->playersScore[$login] = '0';
		// Play sound ?
		$this->soundToPlay(self::ENABLE_PLAYER_CONNECTED_SOUND, self::SOUND_LINK_PLAYER_CONNECTED, $login);
		// Display 
		$this->addMenuIcon($player);
	}
	
	/**
	 * Function handling on the disconnection of a player.
	 *
	 * @param array $callback
	 */
	public function handlePlayerDisconnect(Player $player) {
		$login = $player->login;
		// Play sound ?
		$this->soundToPlay(self::ENABLE_PLAYER_DISCONNECTED_SOUND, self::SOUND_LINK_PLAYER_DISCONNECTED, $login);
		// Removing informations from this player
		unset($this->playersScore[$login]);
	}
	
	
	
	/**
	 * Function called when starting a new map
	 */
	public function onBeginMap() {
		// Initialisation players's score
		$this->initializePlayersScore();
		
		// Music to play ?
		$this->maniaControl->timerManager->registerOneTimeListening($this, 'musicToPlay', 5500);
		
		// Update ranking
		$this->ranking();
		
		// Sound ?
		$this->maniaControl->timerManager->registerOneTimeListening($this, 'playBeginMapSound', 3000);
	}
	
	/*
	 * Play BEGIN_MAP sound
	 */
	public function playBeginMapSound() {
		// Sound to play ?
		$this->soundToPlay(self::ENABLE_BEGIN_MAP_SOUND, self::SOUND_LINK_BEGIN_MAP, null);
	}
	
	
	
	/**
	 * Function called when starting a new round
	 */
	public function onBeginPlaying() {
		$this->maniaControl->timerManager->registerOneTimeListening($this, 'playBeginPlayingSound', 3000);
		
		// Reset killstreak ?
		$RESET_ON_NEW_ROUND = $this->maniaControl->settingManager->getSettingValue($this, self::RESET_ON_NEW_ROUND);
		if ($RESET_ON_NEW_ROUND) {
			// Reset scores
			$this->initializePlayersScore();
			
			// Update ranking
			$this->ranking();
		}
	}
	
	/*
	 * Play BEGING_PLAYING sound
	 */
	public function playBeginPlayingSound() {
		$this->soundToPlay(self::ENABLE_BEGIN_PLAYING_SOUND, self::SOUND_LINK_BEGIN_PLAYING, null);
	}
	
	
	
	/**
	 * Function called when some captures a pole
	 */
	// https://github.com/ManiaControl/ManiaControl/blob/master/core/Callbacks/Structures/CaptureStructure.php
	public function onCapture(CaptureStructure $structure) {
		foreach ($structure->getPlayerArray() as $player) {
			// DEBUG
			$this->toLog($player->nickname . '$z$s$fff : Nice capture !');
			
			// BLUE/RED TEAM SCORES
			$this->playerTeamId = $player->teamId;
			if (!$this->isIgnored($player->login)) {
				$this->maniaControl->timerManager->registerOneTimeListening($this, 'playTeamScoresSound', 1000); // OK
			}
		}
	}
	
	/*
	 * Play BLUE/RED TEAM SCORES sound
	 */
	public function playTeamScoresSound() {
		if ($this->playerTeamId == 0) {
			$this->soundToPlay(self::ENABLE_TEAM_SCORES_SOUND, self::SOUND_LINK_BLUE_TEAM_SCORES, null);
		}
		else {
			$this->soundToPlay(self::ENABLE_TEAM_SCORES_SOUND, self::SOUND_LINK_RED_TEAM_SCORES, null);
		}
	}
	
	
	
	/**
	 * Function called when someone BACKSPACE (+ suppr ?)
	 */
	public function onRequestRespawn(Player $player) {
		$playerNickname	= $player->nickname;
		$playerLogin	= $player->login;
		// Reset player's score
		$this->playersScore[$playerLogin] = '0';
		// Sound to play ?
		$rc = $this->soundToPlay(self::ENABLE_BACKSPACE_SOUND, self::SOUND_LINK_BACKSPACE, $playerLogin);
		// Message to display ?
		if ($rc) { $this->showMessage($playerNickname . '$z$s$fff : Backspace !', $playerLogin); }
		// Update RANKING
		$this->ranking();
		
		// Score of teams - TO DO
		// Récupérer les paramètres du mode (le temps de chaque phase) et le score de chaque équipe
		// 		S_TimeLimitNormal
		// 		S_TimeLimitReduction
		// 		S_TimeLimitInstant
		//	
		//$this->maniaControl->settingManager->getSetting
	}
	
	
	
	/*
	 * Function called when a player hit another player
	 */
	/*
	public function onShoot(Player $player) {
		$message = $player->nickname . '$z$s$fff : shoot';
		// DEBUG
		//$this->toLog($message);
		// Message to display ?
		$this->showMessage($message, $player->login);
	}
	*/
	
	
	
	/*
	 * Function called when a player hit another player
	 */
	public function onHit(PlayerHitStructure $structure) {
		$shooter = $structure->getShooter();
		$victim = $structure->getVictim();
		$damage = $structure->getDamage();
		$shooterPoints = $structure->getShooterPoints();
		$weapon = $structure->getWeapon();
		$hitDistance = $structure->getHitDistance();
		
		// Play sound ?
		$this->soundToPlay(self::ENABLE_HIT_SOUND, self::SOUND_LINK_HIT, $shooter->login);
	}
	
	
	
	/**
	 * Function called when a player has no more armor (killed by weapon, killed by offzone)
	 *
	 */
	// https://github.com/ManiaControl/ManiaControl/blob/master/core/Callbacks/Structures/ArmorEmptyStructure.php
	public function onArmorEmpty(ArmorEmptyStructure $structure) {
		// Get informations
		$shooter = $structure->getShooter();
		if ($shooter !== null) {
			$shooterLogin = $shooter->login;
			$shooterNickname = $shooter->nickname;
			$shooterTeamId = $shooter->teamId;
			$shooterScore = $this->playersScore[$shooterLogin];
		}
		$victim = $structure->getVictim();
		if ($victim !== null) {
			$victimLogin = $victim->login;
			$victimNickname = $victim->nickname;
			$victimTeamId = $victim->teamId;
			$victimScore = $this->playersScore[$victimLogin];
		}
		$damage = $structure->getDamage();
		$shooterPoints = $structure->getShooterPoints();
		$weapon = $structure->getWeapon();
		
		// DEBUG
		//$msg = 'onArmorEmpty() : shooter=' . $structure->getShooter() . ' / victim=' . $structure->getVictim() . ' / damage=' . $structure->getDamage() . ' / shooterPoints=' . $structure->getShooterPoints() . ' / weapon=' . $structure->getWeapon();
		//if ($shooter !== null && $victim !== null) { $this->toLog($shooterNickname . ' killed ' . $victimNickname . ' !'); }
		
		// KILL BY PLAYER
		if ($shooter !== null) {
			// TEAMKILLER
			if ($shooterTeamId == $victimTeamId) {
				$rc = $this->soundToPlay(self::ENABLE_TEAMKILLER_SOUND, self::SOUND_LINK_TEAMKILLER, $shooterLogin);
				if ($rc) { $this->showMessage($shooterNickname . '$z$s$fff : Team killer !', $shooterLogin); }
			}
			// KILLSTREAK
			else {
				$this->playersScore[$shooterLogin] = $shooterScore + 1;
				
				// Sound to play ?
				$this->killAwards($shooter);
				
				// Delai on killAwards : KO, can't pass parameter
				// File&Line: /srv/shootmania/newspeedball/maniacontrol/core/Callbacks/TimerManager.php: 54
				// [18-Jan-2015 14:15:35 UTC] PHP Notice:  Given Listener (Lumpik\SoundEventsManager) can't handle Timer Callback (No Method 'Lumpik\killAwards(murphyslaw)')! in /srv/shootmania/newspeedball/maniacontrol/core/Callbacks/TimerManager.php on line 54
				// [18-Jan-2015 14:15:38 UTC] [ManiaControl NOTICE]: Given Listener (Lumpik\SoundEventsManager) can't handle Timer Callback (No Method '')!
				// File&Line: /srv/shootmania/newspeedball/maniacontrol/core/Callbacks/TimerManager.php: 54
				// [18-Jan-2015 14:15:38 UTC] PHP Notice:  Given Listener (Lumpik\SoundEventsManager) can't handle Timer Callback (No Method '')! in /srv/shootmania/newspeedball/maniacontrol/core/Callbacks/TimerManager.php on line 54
				//$this->maniaControl->timerManager->registerOneTimeListening($this, "Lumpik\killAwards($shooterLogin)", 500);
			}
		}
		
		// DEATH
		if ($victim !== null) {
			$this->playersScore[$victimLogin] = '0';
			
			// DEATH BY OFF-ZONE
			if ($shooter === null) {
				$rc = $this->soundToPlay(self::ENABLE_OFFZONE_SOUND, self::SOUND_LINK_OFFZONE, $victimLogin);
				if ($rc) { $this->showMessage($victimNickname . '$z$s$fff : Off-zoned !', $victimLogin); }
			}
		}
		
		// Update RANKING
		$this->ranking();
	}
	
	
	
	/**
	 * Get the ranking of the 3 best killstreakers and display a widget of killstreak ranking
	 */
	public function ranking() {
		$killStreak_1_player	= null;
		$killStreak_1_score		= 0;
		$killStreak_2_player	= null;
		$killStreak_2_score		= 0;
		$killStreak_3_player	= null;
		$killStreak_3_score		= 0;
		
		// Sort array by descending scores
		arsort($this->playersScore);
		$i = 0;
		// Get the 3 best killstreak players with a score >= 1st score to play sounds
		foreach ($this->playersScore as $player => $score) {
			// Don't treat IGNORED players
			if ($this->isIgnored($player)){ break; }
			
			// Don't treat scores lower than the minimum score needed to play the 1st sound
			//$this->toLog('score=' . $score . ' for ' . $player . ' (min=' . $this->scoreMin . ' - max=' . $this->scoreMax . ')');
			if ($score < $this->scoreMin) { break; }
			
			$i = $i + 1;
			
			// 1st best killstreak player
			if ($i == 1) {
				$killStreak_1_player	= $player;
				$killStreak_1_score		= $score;
			}
			// 2nd best killstreak player
			else if ($i == 2) {
				$killStreak_2_player	= $player;
				$killStreak_2_score		= $score;
			}
			// 3rd best killstreak player
			else if ($i == 3) {
				$killStreak_3_player	= $player;
				$killStreak_3_score		= $score;
			}
			
			// Get only 3 best players
			if ($i == 3) { break; }
		}
		
		// Display the widget of killstreak ranking
		$this->showRanking($killStreak_1_player, $killStreak_1_score, $killStreak_2_player, $killStreak_2_score, $killStreak_3_player, $killStreak_3_score);
	}
	
	/**
	 * Play sounds if the $player has a good score
	 *
	 * @param Player player
	 */
	public function killAwards(Player $player) {
		$playerLogin = $player->login;
		$playerNickname = $player->nickname;
		
		// Kill awards activated ?
		$ENABLE_KILL_AWARDS = $this->maniaControl->settingManager->getSettingValue($this, self::ENABLE_KILL_AWARDS);
		if ($ENABLE_KILL_AWARDS == false) { return; }
		
		// Get parameters
		// NB : can't use dynamic variables for "self::SOUND_LINK_KILL_XX"
		$SOUND_LINK_KILL_01 = $this->maniaControl->settingManager->getSettingValue($this, self::SOUND_LINK_KILL_01);
		$SOUND_LINK_KILL_02 = $this->maniaControl->settingManager->getSettingValue($this, self::SOUND_LINK_KILL_02);
		$SOUND_LINK_KILL_03 = $this->maniaControl->settingManager->getSettingValue($this, self::SOUND_LINK_KILL_03);
		$SOUND_LINK_KILL_04 = $this->maniaControl->settingManager->getSettingValue($this, self::SOUND_LINK_KILL_04);
		$SOUND_LINK_KILL_05 = $this->maniaControl->settingManager->getSettingValue($this, self::SOUND_LINK_KILL_05);
		$SOUND_LINK_KILL_06 = $this->maniaControl->settingManager->getSettingValue($this, self::SOUND_LINK_KILL_06);
		$SOUND_LINK_KILL_07 = $this->maniaControl->settingManager->getSettingValue($this, self::SOUND_LINK_KILL_07);
		$SOUND_LINK_KILL_08 = $this->maniaControl->settingManager->getSettingValue($this, self::SOUND_LINK_KILL_08);
		$SOUND_LINK_KILL_09 = $this->maniaControl->settingManager->getSettingValue($this, self::SOUND_LINK_KILL_09);
		$SOUND_LINK_KILL_10 = $this->maniaControl->settingManager->getSettingValue($this, self::SOUND_LINK_KILL_10);
		$SOUND_LINK_KILL_11 = $this->maniaControl->settingManager->getSettingValue($this, self::SOUND_LINK_KILL_11);
		$SOUND_LINK_KILL_12 = $this->maniaControl->settingManager->getSettingValue($this, self::SOUND_LINK_KILL_12);
		$SOUND_LINK_KILL_13 = $this->maniaControl->settingManager->getSettingValue($this, self::SOUND_LINK_KILL_13);
		$SOUND_LINK_KILL_14 = $this->maniaControl->settingManager->getSettingValue($this, self::SOUND_LINK_KILL_14);
		$SOUND_LINK_KILL_15 = $this->maniaControl->settingManager->getSettingValue($this, self::SOUND_LINK_KILL_15);
		$SOUND_LINK_KILL_16 = $this->maniaControl->settingManager->getSettingValue($this, self::SOUND_LINK_KILL_16);
		$SOUND_LINK_KILL_17 = $this->maniaControl->settingManager->getSettingValue($this, self::SOUND_LINK_KILL_17);
		$SOUND_LINK_KILL_18 = $this->maniaControl->settingManager->getSettingValue($this, self::SOUND_LINK_KILL_18);
		$SOUND_LINK_KILL_19 = $this->maniaControl->settingManager->getSettingValue($this, self::SOUND_LINK_KILL_19);
		$SOUND_LINK_KILL_20 = $this->maniaControl->settingManager->getSettingValue($this, self::SOUND_LINK_KILL_20);
		$SOUND_LINK_KILL_21 = $this->maniaControl->settingManager->getSettingValue($this, self::SOUND_LINK_KILL_21);
		$SOUND_LINK_KILL_22 = $this->maniaControl->settingManager->getSettingValue($this, self::SOUND_LINK_KILL_22);
		$SOUND_LINK_KILL_23 = $this->maniaControl->settingManager->getSettingValue($this, self::SOUND_LINK_KILL_23);
		$SOUND_LINK_KILL_24 = $this->maniaControl->settingManager->getSettingValue($this, self::SOUND_LINK_KILL_24);
		$SOUND_LINK_KILL_25 = $this->maniaControl->settingManager->getSettingValue($this, self::SOUND_LINK_KILL_25);
		$SOUND_LINK_KILL_26 = $this->maniaControl->settingManager->getSettingValue($this, self::SOUND_LINK_KILL_26);
		$SOUND_LINK_KILL_27 = $this->maniaControl->settingManager->getSettingValue($this, self::SOUND_LINK_KILL_27);
		$SOUND_LINK_KILL_28 = $this->maniaControl->settingManager->getSettingValue($this, self::SOUND_LINK_KILL_28);
		$SOUND_LINK_KILL_29 = $this->maniaControl->settingManager->getSettingValue($this, self::SOUND_LINK_KILL_29);
		$SOUND_LINK_KILL_30 = $this->maniaControl->settingManager->getSettingValue($this, self::SOUND_LINK_KILL_30);
		
		// Last SOUND_LINK and KILLSTREAK associated ?
		// For all 30 variables, starting from the last...
		for ($i = 30; $i >= 0; $i--) {
			// Get $i in 2 digits
			$i_2digits = sprintf("%02u",$i);
			// if the "SOUND_LINK_KILL" variable is not empty...
			if (!empty(${"SOUND_LINK_KILL_$i_2digits"})) {
				// Store SOUND_LINK and KILLSTREAK associated
				$this->scoreMax = $i;
				$this->soundLinkMax = ${"SOUND_LINK_KILL_$i_2digits"} ;
				// Stop looping
				break;
			}
		}
		
		// First SOUND_LINK and KILLSTREAK associated ?
		// For all 30 variables, starting from the first...
		for ($i = 1; $i <= 30 ; $i++) {
			// Get $i in 2 digits
			$i_2digits = sprintf("%02u",$i);
			// if the "SOUND_LINK_KILL" variable is not empty...
			if (!empty(${"SOUND_LINK_KILL_$i_2digits"})) {
				// Store SOUND_LINK and KILLSTREAK associated
				$this->scoreMin = $i;
				$this->soundLinkMin = ${"SOUND_LINK_KILL_$i_2digits"} ;
				// Stop looping
				break;
			}
		}
		
		// Play sound depending of player's score
		if (!is_null($playerLogin)) {
			$playerScore = $this->playersScore[$playerLogin];
			// Infinite "last-sound" if scoreMax hited
			if ($playerScore >= $this->scoreMax) { 
				// $this->toLog($playerNickname . '$z$s$fff : Kill ' . $playerScore . ' !!');
				$rc = $this->playSound($this->soundLinkMax, $playerLogin);
				if ($rc) { $this->showMessage($playerNickname . '$z$s$fff : Kill ' . $playerScore . ' !!', $playerLogin); }
			}
			// Or just sounds depending on killstreak of the player
			else {
				// $this->toLog($playerNickname . '$z$s$fff : Kill ' . $playerScore . ' !');
				$playerScore_2digits = sprintf("%02u",$playerScore);
				$SOUND_LINK = ${"SOUND_LINK_KILL_$playerScore_2digits"};
				$rc = $this->playSound($SOUND_LINK, $playerLogin);
				if ($rc) { $this->showMessage($playerNickname . '$z$s$fff : Kill ' . $playerScore . ' !', $playerLogin); }
			}
			
		}
	}
	
	
	
	
	
	
	
	
	
	// Cf SBXmlRpc::OnPass(_Event) from https://github.com/steeffeen/ManiaPlanet-Scripts/blob/master/Modes/ShootMania/SpeedBall.Script.txt
	// which calls onPass() from https://github.com/steeffeen/ManiaPlanet-Scripts/blob/master/Libs/steeffeen/ShootMania/SpeedBallXmlRpc.Script.txt
	public function onPass(Array $array) {
		$shooterLogin = $array[1][0];
		$victimLogin = $array[1][1];
		$shooterNickname = $this->maniaControl->getPlayerManager()->getPlayer($shooterLogin)->nickname;
		$victimNickname = $this->maniaControl->getPlayerManager()->getPlayer($victimLogin)->nickname;
		//$this->toLog($shooterNickname . ' $z$s$fff : Nice pass to ' . $victimNickname . ' !');
	}
	
	
	
	
	
	
	/**
	 * Function called when a weapon (all ?) was near an enemy
	 */
	// https://github.com/ManiaControl/ManiaControl/blob/master/core/Callbacks/Structures/NearMissStructure.php
	// TO MODIF ?
	public function onNearMiss(NearMissStructure $structure) {
		//$msg = 'onNearMiss() : shooter=' . $structure->getShooter() . ' / victim=' . $structure->getVictim() . ' / distance=' . $structure->getDistance() . ' / weapon=' . $structure->getWeapon();
		//$this->toLog($msg);
	}
	
	
	
	
	
	
     /**
     * Get plugin id
     *
     * @return int
     */
    public static function getId() {
        return self::ID;
    }

    /**
     * Get Plugin Name
     *
     * @return string
     */
    public static function getName() {
        return self::NAME;
    }

    /**
     * Get Plugin Version
     *
     * @return float,,
     */
    public static function getVersion() {
        return self::VERSION;
    }

    /**
     * Get Plugin Author
     *
     * @return string
     */
    public static function getAuthor() {
        return self::AUTHOR;
    }

    /**
     * Get Plugin Description
     *
     * @return string
     */
    public static function getDescription() {
        return self::DESCRIPTION;
    }
}

